*
%arg_names =		  ( "B" => "byte", # Aussehen der Rueckgabeparameter 
                        "C" => "char",
                        "D" => "double",
                        "F" => "float",
                        "I" => "int",
                        "J" => "long",
                        "S" => "short",
                        "Z" => "bool",
						"V" => "void"
						); 
sub argument
{
	#erstes Argument in $x
	my $x=$_[0];

	local $dim=0;
	while((substr $x,0,1) eq "[")
	{
		$x=substr $x,1;$dim++; # Anzahl fuehrender "["s ermitteln
	}

	if($arg_names{$x})         #primitiver Typ?
	{return $arg_names{$x}.("[]"x$dim);
	}   #ja- Uebersetzung zurueckgeben else				    
	{return (substr $x,1,-1).("[]"x$dim);}               #nein- Objektnamen zurueckgeben
}

*******************************************
constants_head  ""
constant  ""
constants_seperator  ""
constans_seperator  "$pool[$name_index]"
constant  "\t\tconstant[$i]=$value\n"
constants_tail  ""
this_class  " $name\n"
super_class  ".super $name\n"
#interfaces_head  "$num Interfaces\n"
#interface  " Interface: $name\n"
#interfaces_separator  ""
#interfaces_tail  "\n"
fields_head  "\n"
fields_separator  ""
fields_tail  "\n"
methods_head  "\n"
arguments_head  "arguments ("
arguments_seperator  ","
throws_head  ""
thows_separator  ""
throw  ""
throws_tail  ""
ops_head  ""
op  "\t\t"
ops_separator  "\n"
ops_tail  "\n"
methods_separator  ""
methods_tail  ""
attributes_head  ""
attribute  ""
source_file  "; Source: $name \n"
attributes_separator  ""
attributes_tail  ""
nop                  "nop"
aconst_null          "aconst_null"
iconst_m1            "iconst_m1"
iconst_0             "iconst_0"
iconst_1             "iconst_1"
iconst_2             "iconst_2"
iconst_3             "iconst_3"
iconst_4             "iconst_4"
iconst_5             "iconst_5"
lconst_0             "lconst_0"
lconst_1             "lconst_1"
fconst_0             "fconst_0"
fconst_1             "fconst_1"
fconst_2             "fconst_2"
dconst_0             "dconst_0"
dconst_1             "dconst_1"
bipush               "bipush $arg[0]"
sipush               "sipush $arg[0]"
ldc                  "ldc $xpool[$arg[0]]"
ldc_w                "ldc_w $xpool[$arg[0]]"
ldc2_w               "ldc2_w $xpool[$arg[0]]"
iload                "iload $arg[0]"
lload                "lload $arg[0]"
fload                "fload $arg[0]"
dload                "dload $arg[0]"
aload                "aload $arg[0]"
iload_0              "iload_0"
iload_1              "iload_1"
iload_2              "iload_2"
iload_3              "iload_3"
lload_0              "lload_0"
lload_1              "lload_1"
lload_2              "lload_2"
lload_3              "lload_3"
fload_0              "fload_0"
fload_1              "fload_1"
fload_2              "fload_2"
fload_3              "fload_3"
dload_0              "dload_0"
dload_1              "dload_1"
dload_2              "dload_2"
dload_3              "dload_3"
aload_0              "aload_0"
aload_1              "aload_1"
aload_2              "aload_2"
aload_3              "aload_3"
iaload               "iaload"
laload               "laload"
faload               "faload"
daload               "daload"
aaload               "aaload"
baload               "baload"
caload               "caload"
saload               "saload"
istore               "istore $arg[0]"
lstore               "lstore $arg[0]"
fstore               "fstore $arg[0]"
dstore               "dstore $arg[0]"
astore               "astore $arg[0]"
istore_0             "istore_0"
istore_1             "istore_1"
istore_2             "istore_2"
istore_3             "istore_3"
lstore_0             "lstore_0"
lstore_1             "lstore_1"
lstore_2             "lstore_2"
lstore_3             "lstore_3"
fstore_0             "fstore_0"
fstore_1             "fstore_1"
fstore_2             "fstore_2"
fstore_3             "fstore_3"
dstore_0             "dstore_0"
dstore_1             "dstore_1"
dstore_2             "dstore_2"
dstore_3             "dstore_3"
astore_0             "astore_0"
astore_1             "astore_1"
astore_2             "astore_2"
astore_3             "astore_3"
iastore              "iastore"
lastore              "lastore"
fastore              "fastore"
dastore              "dastore"
aastore              "aastore"
bastore              "bastore"
castore              "castore"
sastore              "sastore"
pop                  "pop"
pop2                 "pop2"
dup                  "dup"
dup_x1               "dup_x1"
dup_x2               "dup_x2"
dup2                 "dup2"
dup2_x1              "dup2_x1"
dup2_x2              "dup2_x2"
swap                 "swap"
iadd                 "iadd"
ladd                 "ladd"
fadd                 "fadd"
dadd                 "dadd"
isub                 "isub"
lsub                 "lsub"
fsub                 "fsub"
dsub                 "dsub"
imul                 "imul"
lmul                 "lmul"
fmul                 "fmul"
dmul                 "dmul"
idiv                 "idiv"
ldiv                 "ldiv"
fdiv                 "fdiv"
ddiv                 "ddiv"
irem                 "irem"
lrem                 "lrem"
frem                 "frem"
drem                 "drem"
ineg                 "ineg"
lneg                 "lneg"
fneg                 "fneg"
dneg                 "dneg"
ishl                 "ishl"
lshl                 "lshl"
ishr                 "ishr"
lshr                 "lshr"
iushr                "iushr"
lushr                "lushr"
iand                 "iand"
land                 "land"
ior                  "ior"
lor                  "lor"
ixor                 "ixor"
lxor                 "lxor"
iinc                 "iinc $arg[0],$arg[1] "
i2l                  "i2l"
i2f                  "i2f"
i2d                  "i2d"
l2i                  "l2i"
l2f                  "l2f"
l2d                  "l2d"
f2i                  "f2i"
f2l                  "f2l"
f2d                  "f2d"
d2i                  "d2i"
d2l                  "d2l"
d2f                  "d2f $arg[0]"
i2b                  "i2b"
i2c                  "i2c"
i2s                  "i2s"
lcmp                 "lcmp"
fcmpl                "fcmpl"
fcmpg                "fcmpg"
dcmpl                "dcmpl"
dcmpg                "dcmpg"
tableswitch          "tableswitch"
lookupswitch         "lookupswitch"
ireturn              "ireturn"
lreturn              "lreturn"
freturn              "freturn"
dreturn              "dreturn"
areturn              "areturn"
return               "return"
getstatic            "getstatic $arg[0]"
putstatic            "putstatic $arg[0]"
getfield             "getfield $arg[0]"
putfield             "putfield $arg[0]"
#invokevirtual        "invokevirtual $arg[0]"
#invokespecial        "invokespecial $arg[0]"
#invokestatic         "invokestatic $arg[0]"
#invokeinterface      "invokeinterface $xpool[$arg[0]] ($arg[1] args)"
new                  "new $arg[0]"
newarray             "newarray $arg[0]"
anewarray            "anewarray $xpool[$arg[0]]"
arraylength          "arraylength"
athrow               "athrow"
checkcast            "checkcast $arg[0]"
instanceof           "instanceof $arg[0]"
monitorenter         "monitorenter"
monitorexit          "monitorexit"
WIDE                 "WIDE"
multianewarray       "multianewarray"
ifnull               "ifnull $arg[0]"
ifnonnull            "ifnonnull $arg[0]"
goto_w               "goto_w $arg[0]"
jsr_w                "jsr_w $arg[0]"
breakpoint           "breakpoint"
impdep1              "impdep1"
impdep2              "impdep2"
goto                 "goto label$label"
jsr                  "jsr label$label"
ret                  "ret label$label"
ifeq                 "ifeq label$label"
ifne                 "ifne label$label"
iflt                 "iflt label$label"
ifge                 "ifge label$label"
ifgt                 "ifgt label$label"
ifle                 "ifle label$label"
if_icmpeq            "if_icmpeq label$label"
if_icmpne            "if_icmpne label$label"
if_icmplt            "if_icmplt label$label"
if_icmpge            "if_icmpge label$label"
if_icmpgt            "if_icmpgt label$label"
if_icmple            "if_icmple label$label"
if_acmpeq            "if_acmpeq label$label"
if_acmpne            "if_acmpne label$label"
iload_0              "iload_0"
iload_1              "iload_1"
iload_2              "iload_2"
iload_3              "iload_3"
method_head			 "\n.method ".("public "x$ACC_PUBLIC).("final "x$ACC_FINAL).("protected "x$ACC_PROTECTED).("static "x$ACC_STATIC).("final "x$ACC_FINAL).("synchronized "x$ACC_SYNCHRONIZED).("native "x$ACC_NATIVE).("abstract "x$ACC_ABSTRACT)." $name"
method_tail			 "\n.end method\n"
argument             $descriptor
arguments_tail		 ")$returndescriptor"."\n"
arguments_head		 "("
arguments_separator  ","
#invokespecial		 "invokespecial $pool[$pool[$pool[$arg[0]]]]/$pool[$pool[$pool2[$arg[0]]]]"
#invokestatic		 "invokestatic $pool[$pool[$pool[$arg[0]]]]/$pool[$pool[$pool2[$arg[0]]]]"
#invokevirtual		 "invokevirtual $pool[$pool[$pool[$arg[0]]]]/$pool[$pool[$pool2[$arg[0]]]]"
invokespecial		 "invokespecial $xpool[$arg[0]]"
invokestatic		 "invokestatic $xpool[$arg[0]]"
invokevirtual		 "invokevirtual $xpool[$arg[0]]"
getstatic            "getstatic $xpool[$arg[0]]"
putstatic            "putstatic $xpool[$arg[0]]"
getfield             "getfield $xpool[$arg[0]]"
putfield             "putfield $xpool[$arg[0]] $pool[$pool2[$pool2[$arg[0]]]]"
getstatic			 "getstatic $xpool[$arg[0]]"
new                  "new $xpool[$arg[0]]"
ops_head			 "\n"
op					 ""
default				 "label$labelnr:\n\t\t"
case				 "label$labelnr:\n\t\t"
label				 "label$labelnr:\n\t\t"
field                ".field ".("public "x$ACC_PUBLIC).("private "x$ACC_PRIVATE).("protected "x$ACC_PROTECTED).("static "x$ACC_STATIC).("final "x$ACC_FINAL).("volatile "x$ACC_VOLATILE).("transient "x$ACC_TRANSIENT)." "."$name"." $type ".(("=".$xpool[$constant_index])x($constant_index>0))."\n"
clean				 "\t\t"
CONSTANT_Utf8  "\"$str\""
CONSTANT_Integer  "$val"
CONSTANT_Float  "$val"
CONSTANT_Long  "$val"
CONSTANT_Class  "$str"
CONSTANT_String  "\"$str\""
CONSTANT_Fieldref  "$pool[$pool[$class_index]]/$pool[$pool[$nt_index]]"
CONSTANT_Methodref  "$pool[$pool[$class_index]]/$pool[$pool[$nt_index]]$pool[$pool2[$nt_index]]"
CONSTANT_InterfaceMethodref  "$pool[$pool[$class_index]]/$pool[$pool[$nt_index]]"
CONSTANT_NameAndType  "[$pool[$type_index]] $pool[$name_index]"
constant ""
access_flags  ".class ".("public "x$ACC_PUBLIC).("final "x$ACC_FINAL).("interface "x$ACC_INTERFACE).("abstract "x$ACC_ABSTRACT)


